﻿using HPSocketCS;
using NB_IOT_UDP_HP_SCOKET.WWKJUtil;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NB_IOT_UDP_HP_SCOKET
{
    public partial class MainForm_UDP : Form
    {
        #region 定义变量
        private AppState appState = AppState.Stoped;
        private static Thread _SendThread;// 发送的线程
        private static Queue _SendConidQueue = Queue.Synchronized(new Queue()); // 存储连接ID的队列
        //public static Queue _SendSqlQueue = Queue.Synchronized(new Queue());// 存储数据sql

        UdpServer server = new HPSocketCS.UdpServer();

        private delegate void ShowMsg(string msg,ListBox lb);
        private ShowMsg AddMsgDelegate;
        #endregion 

        public MainForm_UDP()
        {
            InitializeComponent();
        }

        private void MainForm_UDP_Load(object sender, EventArgs e)
        {
            //测试 log 
            //LogUtil.WriteLog("hahahahaah");
            try
            {
                //var a = server.MarkSilence;
                server.MarkSilence = true;
                server.DisconnectSilenceConnections(100000);//测试将事假调长
                //server.MarkSilence(true);
                //this.Text = title;
                // 本机测试没必要改地址,有需求请注释或删除
                ///this.txtIpAddress.ReadOnly = true;
                this.groupBox3.Height = 0;
                this.splitContainer1.Height = this.groupBox1.Height + 75;
                #region 启动发送线程
                StarSendThread();
                #endregion

                // 加个委托显示msg,因为on系列都是在工作线程中调用的,ui不允许直接操作
                AddMsgDelegate = new ShowMsg(AddMsg);

                // 设置服务器事件
                server.OnPrepareListen += new ServerEvent.OnPrepareListenEventHandler(OnPrepareListen);
                server.OnAccept += new ServerEvent.OnAcceptEventHandler(OnAccept);
                server.OnHandShake += new ServerEvent.OnHandShakeEventHandler(OnHandShake);
                server.OnSend += new ServerEvent.OnSendEventHandler(OnSend);
                server.OnReceive += new ServerEvent.OnReceiveEventHandler(OnReceive);
                server.OnClose += new ServerEvent.OnCloseEventHandler(OnClose);
                server.OnShutdown += new ServerEvent.OnShutdownEventHandler(OnShutdown);

                // 其他设置
                // server.NoDelay = true;

                SetAppState(AppState.Stoped);
            }
            catch (Exception ex)
            {
                SetAppState(AppState.Error);
                AddMsg(ex.Message,lbReceiveData);
            }
        }

        #region 公共方法

        #region 往listbox加一条项目
        /// <summary>
        /// 往listbox加一条项目
        /// </summary>
        /// <param name="msg"></param>
        void AddMsg(string msg,ListBox lb)
        {
            if (lb.InvokeRequired)
            {
                // 很帅的调自己
                lb.Invoke(AddMsgDelegate, msg, lb);
            }
            else
            {
                if (lb.Items.Count > 100)
                {
                    lb.Items.RemoveAt(0);
                }
                lb.Items.Add(msg);
                lb.TopIndex = lb.Items.Count - (int)(lb.Height / lb.ItemHeight);
                LogUtil.WriteLog(msg);
            }
        }
        #endregion

        #region 设置程序状态
        void SetAppState(AppState state)
        {
            appState = state;
            this.btnStart.Enabled = (appState == AppState.Stoped);
            this.btnStop.Enabled = (appState == AppState.Started);
            this.txtIpAddress.Enabled = (appState == AppState.Stoped);
            this.txtPort.Enabled = (appState == AppState.Stoped);
            this.txtDisConn.Enabled = (appState == AppState.Started);
            this.btnDisconn.Enabled = (appState == AppState.Started && this.txtDisConn.Text.Length > 0);
        }
        #endregion

        #region OnPrepareListen(IServer sender, IntPtr soListen)
        HandleResult OnPrepareListen(IServer sender, IntPtr soListen)
        {
            // 监听事件到达了,一般没什么用吧?

            return HandleResult.Ok;
        }
        #endregion 

        #region OnAccept(IServer sender, IntPtr connId, IntPtr pClient)
        HandleResult OnAccept(IServer sender, IntPtr connId, IntPtr pClient)
        {
            // 客户进入了


            // 获取客户端ip和端口
            string ip = string.Empty;
            ushort port = 0;
            if (server.GetRemoteAddress(connId, ref ip, ref port))
            {
                //AddMsg(string.Format(" > [{0},OnAccept] -> PASS({1}:{2})", connId, ip.ToString(), port));
                AddMsg($" > [{connId},OnAccept] -> PASS({ip.ToString()}:{port})",lbReceiveData);
            }
            else
            {
                //AddMsg(string.Format(" > [{0},OnAccept] -> Server_GetClientAddress() Error", connId));
                AddMsg($" > [{connId},OnAccept] -> Server_GetClientAddress() Error", lbErrorData);
            }


            // 设置附加数据
            ClientInfo clientInfo = new ClientInfo();
            clientInfo.ConnId = connId;
            clientInfo.IpAddress = ip;
            clientInfo.Port = port;
            if (server.SetExtra(connId, clientInfo) == false)
            {
                //AddMsg(string.Format(" > [{0},OnAccept] -> SetConnectionExtra fail", connId));
                AddMsg($" > [{connId},OnAccept] -> SetConnectionExtra fail", lbErrorData);
            }

            return HandleResult.Ok;
        }
        #endregion

        #region OnHandShake(IServer sender, IntPtr connId)
        private HandleResult OnHandShake(IServer sender, IntPtr connId)
        {
            //AddMsg(string.Format(" > [{0},OnHandShake]", connId));
            AddMsg($" > [{connId},OnHandShake]", lbReceiveData);
            return HandleResult.Ok;
        }
        #endregion

        #region OnSend(IServer sender, IntPtr connId, byte[] bytes)
        HandleResult OnSend(IServer sender, IntPtr connId, byte[] bytes)
        {
            // 服务器发数据了
            string str = ProtocolAnalysisTools.ByteToHexCode(bytes, 0, bytes.Length);
            //AddMsg(string.Format(" > [{0},OnSend] -> ({1} bytes)", connId, bytes.Length));
            AddMsg($" > [{connId},OnSend] -> ({bytes.Length} bytes)->{str}", lbSendData);
            return HandleResult.Ok;
        }
        #endregion

        #region OnReceive(IServer sender, IntPtr connId, byte[] bytes)
        HandleResult OnReceive(IServer sender, IntPtr connId, byte[] bytes)
        {
            // 数据到达了
            try
            {
                // 获取附加数据
                var clientInfo = server.GetExtra<ClientInfo>(connId);
                if (clientInfo != null)
                {
                    // clientInfo 就是accept里传入的附加数据了
                    
                    AddMsg($" > [{clientInfo.ConnId},OnReceive] -> {clientInfo.IpAddress}:{clientInfo.Port} ({bytes.Length} bytes)", lbReceiveData);
                    
                    // 将数据压入队列后 吊起线程
                    ProtocolAnalysisTools.UpSimplePack(clientInfo, bytes);
                    //验证包是否正确
                    if (clientInfo.flag)
                    {
                        _SendConidQueue.Enqueue(connId);// 将连接id 压入队列
                        StartOrResumeSendThread();// 调起发送线程
                    }
                    else
                    {
                        //清楚附加数据
                        //server.RemoveExtra(clientInfo.ConnId);  在OnClose中处理了
                        //数据包不正确 直接关闭连接
                        server.Disconnect(connId);
                        //继续收包
                    }
                }
                else
                {
                    
                    AddMsg($" > [{connId},OnReceive] -> ({bytes.Length} bytes)", lbReceiveData);
                }

                //if (server.Send(connId, bytes, bytes.Length))
                //{
                //    return HandleResult.Ok;
                //}
                return HandleResult.Ok;
                //return HandleResult.Error;
            }
            catch (Exception)
            {

                return HandleResult.Ignore;
            }
        }
        #endregion

        #region OnClose(IServer sender, IntPtr connId, SocketOperation enOperation, int errorCode)
        HandleResult OnClose(IServer sender, IntPtr connId, SocketOperation enOperation, int errorCode)
        {
            if (errorCode == 0)
                //AddMsg(string.Format(" > [{0},OnClose]", connId));
                AddMsg($" > [{connId},OnClose]", lbReceiveData);
            else
                //AddMsg(string.Format(" > [{0},OnError] -> OP:{1},CODE:{2}", connId, enOperation, errorCode));
                AddMsg($" > [{connId},OnError] -> OP:{enOperation},CODE:{errorCode}", lbReceiveData);
            // return HPSocketSdk.HandleResult.Ok;
            ClientInfo info = server.GetExtra<ClientInfo>(connId);
            if(info.SendCmdRecordId > 0) { 
                DealWithCacheCommand.UpdataCacheCommandType(info.SendCmdRecordId,info.SendCmdParentId, 3); // 这里有点问题 特殊情况下 会有不更新的
            }
            if (server.RemoveExtra(connId) == false)
            {
                //AddMsg(string.Format(" > [{0},OnClose] -> SetConnectionExtra({0}, null) fail", connId));
                AddMsg($" > [{connId},OnClose] -> SetConnectionExtra({connId}, null) fail", lbErrorData);
            }

            return HandleResult.Ok;
        }
        #endregion

        #region OnShutdown(IServer sender)
        HandleResult OnShutdown(IServer sender)
        {
            // 服务关闭了


            //AddMsg(" > [OnShutdown]");
            AddMsg(" > [OnShutdown]",lbReceiveData);
            return HandleResult.Ok;
        }
        #endregion

        #endregion

        #region 界面按钮事件

        /// <summary>
        /// 连接点关闭按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnDisconn_Click(object sender, EventArgs e)
        {
            try
            {
                IntPtr connId = (IntPtr)Convert.ToInt32(this.txtDisConn.Text.Trim());
                // 断开指定客户
                if (server.Disconnect(connId, true))
                {
                    AddMsg($"$({connId}) Disconnect OK", lbReceiveData);
                }
                else
                {
                    //throw new Exception(string.Format("Disconnect({connId}) Error", lbReceiveData));
                    AddMsg($"Disconnect({connId}) Error", lbErrorData);
                }
            }
            catch (Exception ex)
            {
                AddMsg(ex.Message, lbErrorData);
            }
        }

        /// <summary>
        /// 服务启动按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStart_Click(object sender, EventArgs e)
        {
            try
            {
                
                String ip = this.txtIpAddress.Text.Trim();
                ushort port = ushort.Parse(this.txtPort.Text.Trim());

                // 写在这个位置是上面可能会异常
                SetAppState(AppState.Starting);
                server.IpAddress = ip;
                server.Port = port;
                // 启动服务
                if (server.Start())
                {
                    //this.Text = string.Format("{2} - ({0}:{1})", ip, port, title);
                    SetAppState(AppState.Started);
                    AddMsg($"$Server Start OK -> ({ip}:{port})",lbReceiveData);
                }
                else
                {
                    SetAppState(AppState.Stoped);
                    throw new Exception(string.Format("$Server Start Error -> {0}({1})", server.ErrorMessage, server.ErrorCode));
                }
            }
            catch (Exception ex)
            {
                AddMsg(ex.Message, lbErrorData);
            }
        }
        
        /// <summary>
        /// 服务关闭按钮
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStop_Click(object sender, EventArgs e)
        {
            SetAppState(AppState.Stoping);

            // 停止服务
            AddMsg("$Server Stop",lbReceiveData);
            if (server.Stop())
            {
                SetAppState(AppState.Stoped);
            }
            else
            {
                AddMsg($"$Stop Error -> {server.ErrorMessage}({server.ErrorCode})",lbErrorData);
            }
        }
        
        /// <summary>
        /// 连接点文本框改变
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtDisConn_TextChanged(object sender, EventArgs e)
        {
            //连接点框改变时改变按钮可点击的状态
            this.btnDisconn.Enabled = (appState == AppState.Started && this.txtDisConn.Text.Length > 0);
        }

        /// <summary>
        /// 发送数据listbox清空
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.lbSendData.Items.Clear();
        }

        /// <summary>
        /// 接收数据listbox清空
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.lbReceiveData.Items.Clear();
        }

        /// <summary>
        /// 点击状态栏中状态  用于显示错误listbox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {
            if (this.groupBox3.Visible)
            {
                this.groupBox3.Visible = false;
                this.groupBox3.Height = 0;
                this.splitContainer1.Height = this.splitContainer1.Height + 75;
                //this.groupBox2.Height = this.groupBox2.Height + 75;
            }
            else
            {
                this.groupBox3.Visible = true;
                this.groupBox3.Height = 75;
                this.splitContainer1.Height = this.splitContainer1.Height - 75;
                //this.groupBox2.Height = this.groupBox2.Height - 75;
            }
        }

        #region 监听窗体关闭时
        private void MainForm_UDP_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (e.CloseReason == CloseReason.UserClosing)
            {
                if (MessageBox.Show("确定退出程序?", "提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) != DialogResult.Cancel)
                {
                    Environment.Exit(0);
                }
                else { 
                    base.WindowState = FormWindowState.Minimized;
                    base.Hide();
                    this.notifyIcon1.Visible = true;
                    e.Cancel = true;
                }
            }
            else
            {
                AddMsg($"程序为正常关闭",lbErrorData);
            }
        }
        #endregion

        #region  双击工具栏 小图标
        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            base.Visible = true;
            base.ShowInTaskbar = true;
            base.WindowState = FormWindowState.Maximized;
            base.TopMost = true;
            this.notifyIcon1.Visible = false;
            base.TopMost = false;
        }
        #endregion

#endregion

        #region  处理发送的线程

        #region 启动 发送线程
        private void StarSendThread()
        {
            _SendThread = new Thread(new ThreadStart(DealWithSendThread));
            var a = _SendThread.ThreadState;
            _SendThread.Start();
        }
        #endregion

        #region 启动或者恢复发送线程
        private void StartOrResumeSendThread()
        {
            if (_SendThread == null)
            {
                _SendThread = new Thread(new ThreadStart(DealWithSendThread));
            }
            switch (_SendThread.ThreadState)
            {
                // System.Threading.ThreadState.WaitSleepJoin
                case ThreadState.Stopped:
                case ThreadState.Unstarted://未启动
                    _SendThread.Start();
                    break;
                case ThreadState.Suspended://挂起
                    _SendThread.Resume();
                    break;

            }
        }
        #endregion

        #region 处理 接收的数据
        private void DealWithSendThread()
        {
            //定义变量
            byte[] arr = null;
            bool flag = true;
            int tempComId = 0; // 记录上次的命令id
            int tempParId = 0; // 记录上次的父命令id
            while (true)
            {
                try
                {
                    if (_SendConidQueue.Count == 0)//队列数据为空的时候
                    {
                        _SendThread.Suspend();//挂起线程
                    }
                    else
                    {
                        arr = null;
                        //处理数据
                        IntPtr connId = (IntPtr)_SendConidQueue.Dequeue();
                        ClientInfo info = server.GetExtra<ClientInfo>(connId);//获取附加数据
                        //根据类型处理数据
                        if(info == null)
                        {
                            continue;
                        }
                        flag = ProtocolAnalysisTools.UpPack(info,ref arr);
                        if(info.CmdType == CmdType.NoCmd || arr == null)
                        {
                            server.Disconnect(connId, true);
                            continue;
                        }
                        //Thread.Sleep(1000);
                        server.Send(info.ConnId,arr,arr.Length);// 发送数据
                        //Thread.Sleep(100); 
                        //server.Send(info.ConnId, arr, arr.Length);// 发送数据
                        if (flag)// 判断是否最后一包
                        {
                            //没有
                            arr = null;

                            tempComId = info.SendCmdRecordId;
                            tempParId = info.SendCmdParentId;

                            //flag = DealWithCacheCommand.GainCacheCommandByte(info, ref arr);// 获取缓存数据
                            DealWithCacheCommand.GainCacheCommandByte(info, ref arr);// 获取缓存数据
                            VerifyCacheCommandAndDealWith(info, tempComId, tempParId);// 修改 发送状态
                            server.SetExtra(connId, info);// 更新附加数据
                            if (arr != null)//判断是否还有 缓存指令
                            {
                                server.Send(info.ConnId, arr, arr.Length);
                            }
                            else// 无缓存指令 校时关机(没找到指令先直接断开连接)
                            {
                                server.Disconnect(connId, true);
                            }
                        }
                        else
                        {
                            server.SetExtra(connId, info);// 更新附加数据
                        }
                    }
                }
                catch (Exception ex)
                {
                    LogUtil.WriteLog(ex.Message);
                }
            }
        }
        #endregion



        #endregion

        #region 判断缓存指令的状态并处理 
        /// <summary>
        /// 0 未发 1 发送成功 2 发送中 3 发送过单未全部发送成功
        /// </summary>
        /// <param name="info"></param>
        /// <param name="id"></param>
        /// <param name="parentId"></param>
        private void VerifyCacheCommandAndDealWith(ClientInfo info,int id,int parentId)
        {
            string str = null;
            if (id != 0 )//&& parentId == 0)//处理上次缓存指令的状态
            {
                if(parentId == info.SendCmdParentId)// 父id相等
                {
                    if(id == info.SendCmdRecordId)// 上次id 跟本次id相同说明已经没有后续指令
                    {
                        str = ProtocolAnalysisTools.ByteToHexCode(info.BArr,0, info.BArr.Length);
                        DealWithCacheCommand.UpdataCacheCommandType(info.SendCmdRecordId,info.SendCmdParentId, 1,str);
                        info.SendCmdParentId = 0; info.SendCmdRecordId = 0;
                    }
                }
                else// 父id不相同了 说明 上一条缓存指令发送成功
                {
                    str = ProtocolAnalysisTools.ByteToHexCode(info.BArr, 0, info.BArr.Length);
                    DealWithCacheCommand.UpdataCacheCommandType(id,parentId, 1, str);
                    
                }
            }
            if (info.SendCmdRecordId != 0){// && id != info.SendCmdRecordId) {// 刚发送的缓存指令
                DealWithCacheCommand.UpdataCacheCommandType(info.SendCmdRecordId,parentId, 2);
            }
        }
        #endregion

        
    }


    [StructLayout(LayoutKind.Sequential)]
    public class ClientInfo
    {
        public IntPtr ConnId { get; set; }
        public string IpAddress { get; set; }
        public ushort Port { get; set; }
        public byte[] BArr { get; set; }// 存储最新数据
        public byte[] BSendArr { get; set; }// 存储发送的数据域的数据
        public string Address { get; set; }// 水表地址
        public CmdType CmdType { get; set; }// 指令类型
        public bool flag { get; set; } // 指令是否正确
        public string msg { get; set; } // 返回信息
        public int meterId { get; set; }
        public int SendCmdRecordId { get; set; }// 发送的缓存命令的id
        public int SendCmdParentId { get; set; }// 发送缓存命令的母id
     }
}
