﻿using System;
using System.Linq;
using System.Text;

namespace NB_IOT_UDP_HP_SCOKET.WWKJUtil
{
    /// <summary>
    /// 协议的辅助类
    /// </summary>
    public class ProtocolAnalysisTools
    {

        #region 验证数据包 并简单拆包 UpSimplePack(ClientInfo info,byte[] originData)
        /// <summary>
        /// 验证数据包 并简单拆包  UpSimplePack(ClientInfo info,byte[] originData)
        /// </summary>
        /// <param name="info">udp自带的附加数据的类</param>
        /// <param name="originData">接收的数据包 byte数组</param>
        public static void UpSimplePack(ClientInfo info,byte[] originData)
        {
            #region 定义变量
            byte[] _cmdTypeArr = new byte[2],dataBuffer;
            int dataBufferLength = 0,num = 0;
            byte _chekCode = 0,chekCode = 0;//下划线 数据包中的校验和 没有下滑线 计算出的校验和
            #endregion

            #region 初始话赋值
            info.flag = true;
            info.CmdType = CmdType.NoCmd;
            info.BArr = null;
            //info.
            #endregion
            LogUtil.WriteLog($"接收的数据: "+ ByteToHexCode(originData,0,originData.Length));
            #region 逻辑处理

            #region  检查包头包尾 获取数据长度 把数据临时存入 databuffer中
            for (int i = 0; i < originData.Length; i++)
            {
                // 检测包的位置
                if (originData[i] == 0xA5 && originData[originData.Length - 1] == 0xAA)
                {
                    num = i;
                    // 包的最小长度为18
                    if (18 < originData.Length)
                    {
                        byte hL = originData[num + 1]; 
                        byte lL = originData[num + 2];
                        // 获取数据区域的长度
                        dataBufferLength = (hL << 8) + lL;
                        if (dataBufferLength > 12)
                        {
                            dataBufferLength = dataBufferLength - 10; // 减去 控制码和水表地址的长度
                            chekCode = SumCheck(originData, num + 4, originData.Length-2);// 计算校验和
                            _chekCode = originData[originData.Length - 2];//校验和
                            if(true)// (chekCode == _chekCode)
                            {
                                _cmdTypeArr[0] = originData[num + 4];//控制码    
                                _cmdTypeArr[1] = originData[num + 5];//辅助控制码
                                dataBuffer = new byte[dataBufferLength];
                                info.CmdType = GetFunc(_cmdTypeArr);// 指令类型
                                info.Address = ByteToHexCodeLToH(originData, num+7, num+13);
                                //将数据域复制到 dataBufferLength 数组中 表地址后边的数据域  
                                Array.Copy(originData, num + 14, dataBuffer, 0, dataBufferLength - 10);
                                info.BArr = dataBuffer;
                                info.msg = "校验成功";
                            }
                            else
                            {
                                
                                info.flag = false;
                                info.msg = "校验失败";
                            }
                        }
                        else
                        {
                            info.flag = false;
                            info.msg = "数据帧不完整";
                        }
                        break;
                        

                    }
                    else
                    {
                        //  Debug.WriteLine("################" + num + 1 + "#############" + num + 2);
                        info.flag = false;
                        info.msg = "数据帧不完整";
                    }
                }
            }
            #endregion

            #region  校验数据 并解析部分数据

            #endregion

            #endregion
        }

        #region 解包 UpPack(ClientInfo info,ref byte[] datas)
        /// <summary>
        /// 将数据域的数据进行解析
        /// </summary>
        /// <param name="info"></param>
        /// <param name="datas">返回的byte数组</param>
        public static bool UpPack(ClientInfo info,ref byte[] datas)
        {

            #region 定义变量
            DateTime time = DateTime.Now;
            bool isLastPack = true;//是否有后续包
            //byte[]
            datas = null;
            //var datas = jobj["Data"];
            //表地址
            string meterAddr = null;
            //电量
            string BatteryLevel = null;
            //信号强度
            string RSRP = null;
            //信号覆盖等级
            string ECL = null;
            //信噪比
            string SNR = null;
            string deviceId = null;//item["deviceId"].ToString();
            string timeOfReading = null;//采集数据时间

            string dailyFlow = null; //零点累计流量
            string dailyReverseFlow = null;//零点累计逆流值
            string peakFlowRate = null;//日最高流速
            string peakFlowRateTime = null;//日最高流速时间
            string intervalFlow = null;//间隔流量
            string intervalFlowStartingTime = null;//间隔流量开始时间
            string sCumulative = null;//净累计流量
            string pCumulative = null;//正累计流量
            //负累计流量
            string nCumulative = null;
            //瞬时流量
            string wCumulative = null;
            //阀门状态 
            string ValveStatus = null;//00 开01 关 11 异常
            //电池状态
            string BatteryStatus = null;//00:正常 01：欠压
            //磁攻击
            string CiGJ = null;//00:无 01：有;
            //流量状态
            string LLState = null;
            //读取时间
            string ReadTime = null;
            //校验时间
            string CheckMeterTime = null,factTime = null, upLoadTime = null, gainDataTime= null, ip = null;

            int NUM = 0, totalNum = 0, upLoadPeriod = 0, gainDataPeriod = 0, port=0, reSendNumber =0;
            int resultStatue = 0;
            decimal maxFlow = 0;
            StringBuilder sb = new StringBuilder(256);
            string sql = null;

            //sb.Append(" DECLARE @id INT ");
            //sb.Append(" SELECT @id = MeterID FROM WWKJ_RMRS_MeterInfo WHERE ElecAddress = '").Append(info.Address).Append("' ");
            #endregion

            try
            {
                info.BSendArr = null;

                #region 判断是否有水表id
                if (info.meterId == 0) //判断是否有水表id
                {
                    sb.Append(" SELECT MeterID FROM WWKJ_RMRS_MeterInfo WHERE right('00000000000000'+[ElecAddress],14) = '").Append(info.Address).Append("' ");
                    info.meterId = DBHelper.ScalarToInt(sb.ToString());
                    sb.Clear();
                    if (info.meterId == 0)
                    {
                        //sb.Append("SELECT ID FROM WWKJ_RMRS_NBBatchRegister where right('00000000000000' + MeterAddr, 14) = '").Append(info.Address).Append("' AND DeleteMark = 0");
                        //info.meterId = DBHelper.ScalarToInt(sb.ToString());
                        //if(info.meterId == 0)// 0 找不到对应的表
                        //{
                        return false;
                        //}
                        //else
                        //{
                        //    info.meterId = -1;// 1 没有进行数据同步
                        //}
                        
                        //sb.Clear();
                    }
                    
                }
                #endregion
                

                switch (info.CmdType)
                {
                    case CmdType.ReadVer:
                        break;
                    case CmdType.ReadTime:
                        break;
                    case CmdType.ReadReportParam:
                        break;
                    case CmdType.ReadMeterAddr:
                        break;
                    case CmdType.ReadMeterParam:
                        break;
                    case CmdType.ReadNetParam:
                        #region 读取网络参数
                        
                        #endregion
                        break;
                    case CmdType.ReadMeterInterval:
                        break;
                    case CmdType.ReadMeterInterval_down:
                        break;
                    case CmdType.ReadReportInfo:
                        break;
                    case CmdType.ReadFreq:
                        break;
                    case CmdType.ReadReportInterval:
                        break;
                    case CmdType.ReadSysInterval:
                        break;
                    case CmdType.ReadSIM:
                        break;
                    case CmdType.ReadFlowAlarm:
                        break;
                    case CmdType.ReadPressuceParam:
                        break;
                    case CmdType.ReadHistory:
                        break;
                    case CmdType.WriteTime:
                        break;
                    case CmdType.WriteReportParam:
                        resultStatue = Convert.ToInt32(info.BArr[0].ToString("X2"));
                        if (resultStatue == 1)
                        {
                            info.msg = "表地址修改成功";
                        }
                        else
                        {
                            info.msg = "表地址修改失败";
                        }
                        break;
                    case CmdType.WriteReportParam_down:
                        resultStatue = Convert.ToInt32(info.BArr[0].ToString("X2"));
                        if (resultStatue == 1)
                        {
                            info.msg = "表地址修改成功";
                        }
                        else
                        {
                            info.msg = "表地址修改失败";
                        }
                        break;
                    case CmdType.WriteMeterAddr:
                        resultStatue = Convert.ToInt32(info.BArr[0].ToString("X2"));
                        if(resultStatue == 1)
                        {
                            info.msg = "表地址修改成功";
                        }
                        else
                        {
                            info.msg = "表地址修改失败";
                        }
                        break;
                    case CmdType.WriteMeterParam:

                        pCumulative = HexCodeToMeterRead(info.BArr, 0).ToString();
                        nCumulative = HexCodeToMeterRead(info.BArr, 6).ToString();

                        break;
                    case CmdType.WriteNetParam:
                        #region  设置网络参数
                        //if() 改了 就接收不到了
                        #endregion 
                        break;
                    case CmdType.WriteAlarm:
                        break;
                    case CmdType.WriteSwitch:
                        break;
                    case CmdType.WriteReportInfo:
                        break;
                    case CmdType.WriteReportInterval:
                        break;
                    case CmdType.WriteAllParam:
                        break;
                    case CmdType.WriteFlowAlarm:
                        break;
                    case CmdType.WriteSysInterval:
                        break;
                    case CmdType.WriteFreq:
                        break;
                    case CmdType.WritePressureParam:
                        break;
                    case CmdType.ClearHistory:
                        break;
                    case CmdType.Send_Update:
                        break;
                    case CmdType.Send_Update_date:
                        break;
                    case CmdType.Send_Finish:
                        break;
                    case CmdType.WriteProgramParam:
                        break;
                    case CmdType.ReadProgramParam:
                        break;
                    case CmdType.ReadProgramAllParam:

                        #region 获取所有参数
                        ////表地址
                        meterAddr = info.Address;
                        ////净累计流量
                        ///ReadTime    = HexCodeToTimeStr(info.BArr, addNum + 16);             //读数时间
                        sCumulative = HexCodeToMeterRead(info.BArr, 0).ToString();// 净累计流量
                        pCumulative = HexCodeToMeterRead(info.BArr, 6).ToString();// 正累计流量
                        nCumulative = HexCodeToMeterRead(info.BArr, 12).ToString();// 负累计流量
                        ////实际时间
                        factTime = HexCodeToTimeStr(info.BArr, 18);
                        ////上报起始时间
                        upLoadTime = HexCodeToTimeStr(info.BArr, 24);
                        ////上报间隔
                        upLoadPeriod = HexTwoToIntLw(info.BArr[30], info.BArr[31]);
                        ////定时采集起始时间
                        gainDataTime = HexCodeToTimeStr(info.BArr, 32);
                        ////采集时间间隔
                        gainDataPeriod = HexTwoToIntLw(info.BArr[38], info.BArr[39]);
                        ////端口号
                        port = HexTwoToIntHight(info.BArr[44], info.BArr[45]);
                        ////IP
                        ip = HexCodeToIpAddress(info.BArr, 40);
                        ////上报重发次数
                        reSendNumber = Convert.ToInt32(info.BArr[46].ToString("X2"));
                        ////最大流量报警值
                        maxFlow = HexCodeToMaxValue(info.BArr,47);

                        #region 拼接sql 
                        sb.Append("INSERT INTO WWKJ_RMRS_AllParam ([meterNewAddr],[staticCumulative],[positiveCumulative],[negativeCumulative],[factTime],[upLoadTime],");
                        sb.Append("[upLoadPeriod],[gainDataTime],[gainDataPeriod],[ip],[port],[reSendNumber],");
                        sb.Append("[maxFlow],[totalNum],[NUM],[imei],meterId) VALUES ('").Append(meterAddr).Append("',");
                        sb.Append(sCumulative).Append(",").Append(pCumulative).Append(",").Append(nCumulative).Append(",'").Append(factTime).Append("','").Append(upLoadTime).Append("',").Append(upLoadPeriod).Append(",'");
                        sb.Append(gainDataTime).Append("',").Append(gainDataPeriod).Append(",'").Append(ip).Append("','").Append(port).Append("',").Append(reSendNumber).Append(",").Append(maxFlow).Append(",0,0,'");
                        sb.Append("',").Append(info.meterId).Append(")");
                        #endregion 

                        #region 处理返回数据  没有下行说行 先用的 心跳包
                        //DateTime time = DateTime.Now;
                        info.BSendArr = new byte[7];
                        info.BSendArr[0] = 0x00;
                        byte[] timeArr = TimeToByteArray(time);
                        Array.Copy(timeArr, 0, info.BSendArr, 1, 6);
                        datas = Pack(info);
                        #endregion 

                        #endregion

                        break;
                    case CmdType.NoCmd:
                        break;
                    case CmdType.ReadHistoryOneNet:

                        #region OneNet 主动上报历史记录
                        int meterNum = Convert.ToInt32(info.BArr[4].ToString("X2"), 16);
                        //表地址
                        meterAddr = info.Address;
                        //总包数
                        totalNum = Convert.ToInt32(HexTwoToIntHight(info.BArr[0], info.BArr[1]));
                        //当前包数
                        NUM = Convert.ToInt32(HexTwoToIntHight(info.BArr[2], info.BArr[3]));
                        //校标时间
                        CheckMeterTime = HexCodeToTimeStr(info.BArr, 5);
                        //电池电量
                        BatteryLevel = Convert.ToInt32(info.BArr[11].ToString("X2"), 16).ToString();
                        //信号轻度
                        RSRP = Convert.ToInt32(info.BArr[12].ToString("X2"), 16).ToString();
                        //信号覆盖等级ECL 
                        ECL = info.BArr[13].ToString("X2");
                        //信噪比SNR
                        if (Convert.ToInt32(info.BArr[14].ToString("X2")) == 0)
                        {
                            SNR = "-";
                        }
                        else
                        {
                            SNR = "+";
                        }
                        
                        SNR = SNR + Convert.ToInt32(info.BArr[15].ToString("X2"), 16);
                       

                        #region 循环历史数据 并拼接sql 
                        for (int k = 0; k < meterNum; k++)
                        {
                            int addNum = k * 32;
                            ReadTime    = HexCodeToTimeStr(info.BArr, addNum + 16);             // 读数时间
                            sCumulative = HexCodeToMeterRead(info.BArr, addNum + 22).ToString();// 净累计流量
                            pCumulative = HexCodeToMeterRead(info.BArr, addNum + 28).ToString();// 正累计流量
                            nCumulative = HexCodeToMeterRead(info.BArr, addNum + 34).ToString();// 负累计流量
                            wCumulative = HexCodeToMeterRead(info.BArr, addNum + 40).ToString();// 瞬时流量

                            byte S1 = info.BArr[46 + addNum];
                            //dt.Battery_num = (Convert.ToDouble(info.BArr[47 + addNum]) + 200) / 100;

                            #region  处理S1
                            if ((S1 & 2) == 0)
                            {
                                if ((S1 & 1) == 0)
                                {
                                    //builder.Append("      " + "阀门当前状态:开");
                                    ValveStatus = "00";
                                }
                                else
                                {
                                    ValveStatus = "01";
                                }
                            }
                            else
                            {
                                if ((S1 & 1) == 0)
                                {
                                    // builder.Append("    阀门状态:关");
                                    ValveStatus = "10";
                                }
                                else
                                {
                                    //builder.Append("      " + "阀门当前状态:异常");
                                    ValveStatus = "11";
                                }
                            }
                            if ((S1 & 8) == 0)
                            {
                                if ((S1 & 4) == 0)
                                {
                                    // builder.Append("      " + "电池电压:正常");
                                    BatteryStatus = "00";
                                }
                                else
                                {
                                    // builder.Append("      " + "电池电压:严重欠压");
                                    BatteryStatus = "01";
                                }

                            }
                            else
                            {
                                if ((S1 & 4) == 0)
                                {
                                    //builder.Append("    电池状态:关");
                                    BatteryStatus = "10";
                                }
                                else
                                {
                                    // builder.Append("      " + "电池状态:严重欠压");
                                    BatteryStatus = "11";
                                }
                            }

                            if ((S1 & 16) == 0)
                            {
                                //builder.Append("      " + "无磁攻击");
                                CiGJ = "00";
                            }
                            else
                            {
                                //builder.Append("      " + "无磁攻击");
                                CiGJ = "01";
                            }

                            if ((S1 & 32) == 0)
                            {
                                //builder.Append("    无磁攻击");
                                CiGJ = "00";
                            }
                            else
                            {
                                // builder.Append("      " + "正在磁攻击");
                                CiGJ = "01";
                            }

                            if ((S1 & 64) == 0)
                            {
                                //builder.Append("      " + "流量状态:正常");
                                LLState = "00";
                            }
                            else
                            {
                                // builder.Append("      " + "流量状态:正常");
                                LLState = "01";
                            }
                            #endregion

                            #region  拼接sql
                            sb.Append("INSERT INTO WWKJ_RMRS_HistoryRecord (MeterID,ValveStatus,Reading,ReadingDT,CreateDT,ReviseDT,BatteryLevel,Total,TotalUp,TotalDown,Instance,BatteryStatus,Attack,Rsrp,Ecl,Snr,MeterAddress) VALUES( ");
                            sb.Append(info.meterId).Append(",'").Append(ValveStatus).Append("','").Append(sCumulative).Append("','").Append(ReadTime).Append("',GETDATE(),GETDATE(),").Append(BatteryLevel).Append(",").Append(sCumulative).Append(",").Append(pCumulative);
                            sb.Append(",").Append(nCumulative).Append(",").Append(wCumulative).Append(",'").Append(BatteryStatus).Append("','").Append(CiGJ).Append("','").Append(FormatValue(RSRP)).Append("','").Append(FormatValue(SNR)).Append("','").Append(FormatValue(ECL)).Append("','").Append(info.Address.TrimStart('0')).Append("') ");

                            if (k == meterNum - 1)// 用最新的一条更新meter表
                            {
                                sb.Append("update WWKJ_RMRS_MeterInfo set NowRadingDT = '").Append(ReadTime).Append("', NowReading = '").Append(sCumulative).Append("', BatteryVoltage = '").Append(BatteryLevel).Append("', OneCursor = '' where MeterID = ").Append(info.meterId);
                            }
                            #endregion
                            
                            //DBHelper.Query(sb.ToString());
                            
                        }
                        #endregion

                        #region  组装发回数据
                        //DateTime time = DateTime.Now;
                        string year = time.Year.ToString();
                        string month = time.Month.ToString();
                        string day = time.Day.ToString();
                        string hour = time.Hour.ToString();
                        string min = time.Minute.ToString();
                        string second = time.Second.ToString();
                        byte year1 = Convert.ToByte(year.Substring(2, 2), 16);
                        byte year2 = Convert.ToByte(year.Substring(0, 2), 16);
                        byte monthB = Convert.ToByte(month, 16);
                        byte dayB = Convert.ToByte(day, 16);
                        byte hourB = Convert.ToByte(hour, 16);
                        byte minB = Convert.ToByte(min, 16);
                        byte secondB = Convert.ToByte(second, 16);
                        byte totalNumByte1 = (byte)(totalNum >> 8);
                        byte totalNumByte2 = (byte)(totalNum & 0xff);
                        byte nextNumByte1 = (byte)(NUM >> 8);
                        byte nextNumByte2 = (byte)(NUM & 0xff);
                        info.BSendArr = new byte[] { year1, monthB, dayB, hourB, minB, secondB, totalNumByte1, totalNumByte2, nextNumByte1, nextNumByte2 };
                        datas = Pack(info,false,1);// 下行包跟其他包不一样 去问问马工 跟文档一样的话 pack方法要修改

                        #endregion

                        if (totalNum > NUM) // 相等时最后一包
                        {
                            isLastPack = false;
                        }
                        #endregion

                        break;
                    default:

                        break;
                }
                sql = sb.ToString();
                DBHelper.Query(sql);
                //#region 检测是否有缓存指令并发送
                //VerifyFlashCommandAndSend();
                //#endregion
                
            }
            catch (Exception ex)
            {
                LogUtil.WriteLog("方法 UpPack(ClientInfo info,ref byte[] datas) -->" + ex.Message);
            }
            return isLastPack;
        }
        #endregion

        #region  解包 辅助方法

        #region 获取控制码  CmdType GetFunc(byte[] cmd)
        private static CmdType GetFunc(byte[] cmd)
        {
            CmdType _cmd = CmdType.NoCmd;
            if (cmd[0] == 0xF0)
            {
                switch (cmd[1])
                {
                    case 0x11:
                        _cmd = CmdType.ReadMeterAddr;
                        break;
                    case 0x12:
                        _cmd = CmdType.ReadVer;//读版本号
                        break;
                    case 0x13:
                        _cmd = CmdType.WriteSwitch;
                        break;
                    case 0x14:
                        _cmd = CmdType.WriteMeterParam;
                        break;
                    case 0x15:
                        _cmd = CmdType.WriteMeterAddr;
                        break;
                    case 0x16:
                        _cmd = CmdType.ReadTime;
                        break;
                    case 0x17:
                        _cmd = CmdType.WriteTime;
                        break;
                    case 0x18:
                        _cmd = CmdType.ReadMeterInterval;
                        break;
                    case 0x19:
                        _cmd = CmdType.WriteReportParam;
                        break;
                    case 0x1A:
                        _cmd = CmdType.ReadNetParam;
                        break;
                    case 0x1B:
                        _cmd = CmdType.WriteNetParam;
                        break;
                    case 0x1C:
                        _cmd = CmdType.ReadHistory;
                        break;
                    case 0x1D:
                        _cmd = CmdType.ReadReportInterval;
                        break;
                    case 0x32:
                        _cmd = CmdType.ReadFreq;
                        break;
                    case 0x1E:
                        _cmd = CmdType.WriteReportInterval;
                        break;
                    case 0x23:
                        _cmd = CmdType.WriteAllParam;
                        break;
                    case 0x30:
                        _cmd = CmdType.ReadFlowAlarm;
                        break;
                    case 0x31:
                        _cmd = CmdType.WriteFlowAlarm;
                        break;
                    case 0x33:
                        _cmd = CmdType.WriteFreq;
                        break;
                    case 0x25:
                        _cmd = CmdType.ReadSIM;
                        break;
                    case 0x26:
                        _cmd = CmdType.WriteAlarm;
                        break;
                    case 0x28:
                        _cmd = CmdType.ReadMeterInterval_down;
                        break;
                    case 0x29:
                        _cmd = CmdType.WriteReportParam_down;
                        break;
                    case 0x20:
                        _cmd = CmdType.Send_Update;
                        break;
                    case 0x21:
                        _cmd = CmdType.Send_Update_date;
                        break;
                    case 0x22:
                        _cmd = CmdType.Send_Finish;
                        break;
                    case 0x37://设置程序参数
                        _cmd = CmdType.WriteProgramParam;
                        break;
                    case 0x36://读程序程序参数
                        _cmd = CmdType.ReadProgramParam;
                        break;
                    case 0x40://读水表所有参数
                        _cmd = CmdType.ReadProgramAllParam;
                        break;
                    case 0x24:
                        _cmd = CmdType.ReadHistoryOneNet;
                        break;
                }
            }

            return _cmd;
        }
        #endregion

        #region 计算校验和 SumCheck(byte[] buffer, int startIndex, int endIndex)
        public static byte SumCheck(byte[] buffer, int startIndex, int endIndex)
        {
            int num = 0;
            for (int i = startIndex; i < endIndex; i++)
            {
                num = num + buffer[i];
                num = num % 256;
            }
            return (byte)num;
        }
        #endregion

        #region byte转16进制 低位在前 ByteToHexCodeLToH(byte[] bytes,int start,int end)
        /// <summary>
        /// byte转16进制 低位在前
        /// </summary>
        /// <param name="bytes"></param>
        /// <param name="start">开位置(含第一位)</param>
        /// <param name="end">结束位置</param>
        /// <returns></returns>
        public static string ByteToHexCodeLToH(byte[] bytes,int start,int end)
        {
            //string str = "";
            StringBuilder sb = new StringBuilder(bytes.Length * 2);
            for (int i = end; i >= start; i--)
            {
                // Debug.WriteLine("################" + buffer[i].ToString("X2"));
                //str += bytes[i].ToString("X2");
                sb.Append(bytes[i].ToString("X2"));
            }
            return sb.ToString();
        }
        #endregion

        #region byte数组转16进制 
        public static string ByteToHexCode(byte[] bytes,int start,int end)
        {
            StringBuilder sb = new StringBuilder(bytes.Length * 2);
            for (int i = start; i < end; i++)
            {
                // Debug.WriteLine("################" + buffer[i].ToString("X2"));
                //str += bytes[i].ToString("X2");
                sb.Append(bytes[i].ToString("X2"));
            }
            return sb.ToString();
        }
        #endregion 

        #region  数组拼接 ArrayConcat(byte[] preArr, byte[] nextArr, int nextIndex = 0)
        public static byte[] ArrayConcat(byte[] preArr, byte[] nextArr, int nextIndex = 0)
        {
            byte[] tempArr = new byte[preArr.Length+nextArr.Length-nextIndex];
            Array.Copy(preArr, 0, tempArr,0, preArr.Length);
            Array.Copy(nextArr, nextIndex, tempArr, preArr.Length, preArr.Length - nextIndex);
            return tempArr;
        }
        #endregion

        #region 16进制数组转时间 HexCodeToTimeStr(byte[] data,int index)
        /// <summary>
        /// 16进制转时间
        /// </summary>
        /// <param name="data">byte数组</param>
        /// <param name="index">起始位置</param>
        /// <returns></returns>
        public static string HexCodeToTimeStr(byte[] data,int index)
        {
            StringBuilder builder = new StringBuilder(20);
            builder.Append("20").Append(Convert.ToString(data[index], 16).PadLeft(2, '0')).Append("-");
            builder.Append(Convert.ToString(data[index + 1], 16).PadLeft(2, '0')).Append("-");
            builder.Append(Convert.ToString(data[index + 2], 16).PadLeft(2, '0')).Append(" ");
            builder.Append(Convert.ToString(data[index + 3], 16).PadLeft(2, '0')).Append(":");
            builder.Append(Convert.ToString(data[index + 4], 16).PadLeft(2, '0')).Append(":");
            builder.Append(Convert.ToString(data[index + 5], 16).PadLeft(2, '0'));

            return builder.ToString();
        }
        #endregion

        #region  16进制数组转累计值 HexCodeToMeterRead(byte[] data,int index)
        public static decimal HexCodeToMeterRead(byte[] data,int index)
        {
            StringBuilder sb = new StringBuilder();
            decimal num = 0;
            sb.Append(data[index + 5].ToString("X2")).Append(data[index + 4].ToString("X2"));
            sb.Append(data[index + 3].ToString("X2")).Append(data[index + 2].ToString("X2"));
            sb.Append(".").Append(data[index + 1].ToString("X2")).Append(data[index].ToString("X2"));
            num = Convert.ToDecimal(sb.ToString());
            return num;
        }
        #endregion

        #region 高位在前 HexTwoToIntHight(byte b1, byte b2)
        public static int HexTwoToIntHight(byte b1, byte b2)// 高位在前
        {
            int num = (b1 << 8) + b2;
            return num;
        }
        #endregion

        #region 低位在前 HexTwoToIntLw(byte b1, byte b2)
        public static int HexTwoToIntLw(byte b1, byte b2) // 地位在前
        {
            int num = (b2 << 8) + b1;
            return num;
        }
        #endregion

        #region 16进制数组转ip地址
        public static string HexCodeToIpAddress(byte[] arr,int index)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(Convert.ToString(arr[index], 10)).Append(".").Append(Convert.ToString(arr[index+1], 10)).Append(".").Append(Convert.ToString(arr[index+2], 10)).Append(".").Append(Convert.ToString(arr[index+3], 10));
            return sb.ToString();
        }
        #endregion

        #region  16进制数组转最大流量 HexCodeToMaxValue(byte[] arr,int index)
        public static decimal HexCodeToMaxValue(byte[] arr, int index)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(arr[index + 5].ToString("X2")).Append(arr[index + 4].ToString("X2")).Append(arr[index + 3].ToString("X2")).Append(arr[index + 2].ToString("X2")).Append(".").Append(arr[index + 1].ToString("X2")).Append(arr[index].ToString("X2"));

            return Convert.ToDecimal(sb.ToString());
        }
        #endregion

        #region  格式话数据,对没有数据的字段格式化为 "--"
        private static string FormatValue(string value)
        {
            if (string.IsNullOrEmpty(value))
            {
                return "--";
            }

            return value;
        }
        #endregion

        #endregion


        #endregion

        #region 数据压包  Pack(ClientInfo info,bool isNextPack = true,int subPackLen = 0)
        /// <summary>
        /// 组合数据 Pack(ClientInfo info,bool isNextPack = true,int subPackLen = 0)
        /// </summary>
        /// <param name="info"></param>
        /// <param name="isNextPack">是否有后续包的字节</param>
        /// <param name="subPackLen">后续字节数</param>
        /// <returns></returns>
        public static byte[] Pack(ClientInfo info,bool isNextPack = true,int subPackLen = 0)
        {
            // 定义变量
            byte[] datas = null;
            byte[] funcCode = new byte[2];
            int dataLength = 0, sendDataLength = 0,dataAreaLength = 0,num = 0;
            byte hl, lL;
            
            //赋值
            dataLength = info.BSendArr.Length;// 穿过来数据的长度
            dataAreaLength = 0x0D + dataLength - subPackLen;//数据域数据长度 
            sendDataLength = 0x0E + dataLength + 0x05 - subPackLen;// 0E 到水表地址的长度 05数据域结束到命令结束的长度

            #region 判断水表类型 计算命令的长度
            //判断水表类型 计算命令的长度
            //目前都是 0x88
            //if(!= 0x88)
            //{
            //    sendDataLength = sendDataLength - 1;
            //}
            #endregion

            datas = new byte[sendDataLength];

            datas[num] = 0xA5; num++;//帧标志 
            hl = (byte)(dataAreaLength >> 8);
            lL = (byte)(dataAreaLength & 0xff);
            // 数据长度
            datas[num] = hl; num++;
            datas[num] = lL; num++;
            datas[num] = 0x5A; num++;//帧标志
            //
            SetFunc(info.CmdType,ref funcCode); // 控制码
            Array.Copy(funcCode, 0, datas, 4, 2); num = num + 2;// 4 5
            datas[num] = 0x88; num++;//表类型
            if (info.Address.Length != 14) // 判断水表的地址码长度
            {
                return null;
            }
            Array.Copy(GetAddrFromStr(info.Address), 0, datas, 7, 7); num = num + 7;// 将水表地址加入数组 // 7 8 9 10 11 12 13
            if (info.BSendArr.Length > 0) // 判断数据包的长度
            {
                Array.Copy(info.BSendArr, 0, datas, 14, dataLength); num = num + dataLength;// 14 - 14+ dataLength
            }
            if (isNextPack) { // 是否有后续的字段
                datas[num] = 0x00; num++;// 有无后续,这里为无后续
            }
            datas[num] = 0x07; num++;// MID
            datas[num] = 0xE0; num++;// MID
            datas[num] = SumCheck(datas, 4, 18 + dataLength); num++; // 校验和
            datas[num] = 0xAA; // 帧结束

            //return ByteToHexStr(datas);
            return datas;
        }
        #region 压包 辅助方法

        #region 设置控制码、副控制码 SetFunc(CmdType cmdType,ref byte[] _funcCode)
        //设置控制码、副控制码
        private static void SetFunc(CmdType cmdType,ref byte[] _funcCode)
        {
            switch (cmdType)
            {
                case CmdType.ReadVer://读表版本
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x12;
                    break;
                case CmdType.ReadTime://读表时间
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x16;
                    break;
                //case CmdType.ReadReportParam://读上报间隔
                //    _funcCode[0]=0xF0;
                //    _funcCode[1] = 0x18;
                //    break;
                case CmdType.ReadMeterAddr://读表地址(读表计数据)
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x11;
                    break;
                case CmdType.ReadMeterParam://读表底数，未时用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x05;
                    break;
                case CmdType.ReadNetParam://读网络参数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x1A;
                    break;
                case CmdType.ReadMeterInterval://读抄表上报间隔
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x18;
                    break;
                case CmdType.ReadMeterInterval_down://读抄表采集间隔
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x28;
                    break;
                case CmdType.WriteReportParam_down://写抄表采集间隔
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x29;
                    break;
                case CmdType.ReadReportInfo://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x07;
                    break;
                case CmdType.ReadReportInterval://读上报重发次数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x1D;
                    break;
                case CmdType.ReadFreq://读上报重发次数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x32;
                    break;
                case CmdType.ReadSysInterval://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x09;
                    break;
                case CmdType.ReadSIM://读IMEI和ICCID
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x25;
                    break;
                case CmdType.ReadPressuceParam://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x0B;
                    break;
                case CmdType.ReadHistory://读历史记录
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x1C;
                    break;
                case CmdType.WriteTime://写表时间
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x17;
                    break;
                case CmdType.WriteReportParam://写上报间隔
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x19;
                    break;
                case CmdType.WriteMeterAddr://写表地址
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x15;
                    break;
                case CmdType.WriteMeterParam://写表底数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x14;
                    break;
                case CmdType.WriteNetParam://写网路参数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x1B;
                    break;
                case CmdType.WriteReportInfo://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x07;
                    break;
                case CmdType.WriteReportInterval://写上报重发次数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x1E;
                    break;
                case CmdType.WriteSysInterval://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x09;
                    break;
                case CmdType.WritePressureParam://未时用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x0B;
                    break;
                case CmdType.ClearHistory://未使用
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x0C;
                    break;
                case CmdType.WriteAlarm://开关报警
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x26;
                    break;
                case CmdType.WriteSwitch://开关阀门
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x13;
                    break;
                case CmdType.WriteAllParam://写上报重发次数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x23;
                    break;
                case CmdType.WriteFlowAlarm://写最大流量报警
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x31;
                    break;
                case CmdType.WriteFreq://写最大流量报警
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x33;
                    break;
                case CmdType.ReadFlowAlarm://写最大流量报警
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x30;
                    break;
                case CmdType.Send_Update://发送升级请求命令
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x20;
                    break;
                case CmdType.Send_Update_date://发送升级数据
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x21;
                    break;
                case CmdType.Send_Finish://发送升级指令
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x22;
                    break;
                case CmdType.WriteProgramParam://设置程序参数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x37;
                    break;
                case CmdType.ReadProgramParam://读程序程序参数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x36;
                    break;
                case CmdType.ReadProgramAllParam://读取水表所有参数
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x40;
                    break;
                case CmdType.ReadHistoryOneNet:
                    _funcCode[0] = 0xF0;
                    _funcCode[1] = 0x24;
                    break;
            }
        }
        #endregion

        #region 将水表地址转成byte数组   GetAddrFromStr(string address)
        private static byte[] GetAddrFromStr(string address)
        {
            byte[] addr = new byte[7];
            for (int i = 0; i<address.Length / 2; i++)
            {
                addr[6 - i] = Convert.ToByte(address.Substring(i* 2, 2), 16);
            }
            return addr;
        }
        #endregion

        #region 将16进制字符串转为byte数组
        public static byte[] HexToByte(string str)
        {
            int length = str.Length / 2;
            byte[] arr = new byte[length];
            for (int i = 0; i < length; i++)
            {
                arr[i] = Convert.ToByte(str.Substring(i * 2, 2), 16);
            }
            return arr;
        }
        #endregion

        #region  将16进制字符串转为byte数组 低位在前 HexToByteByLow(string str)
        public static byte[] HexToByteByLow(string str)
        {
            int length = str.Length / 2;
            byte[] arr = new byte[length];
            for (int i = 0; i < length; i++)
            {
                arr[length - i -1] = Convert.ToByte(str.Substring(i * 2, 2),16);
            }
            return arr;
        }
        #endregion 

        #region byte数组转16进制 ByteToHexStr(byte[] bytes)
        private static string ByteToHexStr(byte[] bytes)
        {
            StringBuilder sb = new StringBuilder(1024);
            for (int i = 0; i < bytes.Length; i++)
            {
                sb.Append(bytes[i].ToString("X2"));
            }
            return sb.ToString();
        }
        #endregion

        #region 将时间转为byte数组 // 默认6个字节长度 TimeToByteArray()
        public static byte[] TimeToByteArray(DateTime time)
        {
            //DateTime time = DateTime.Now;
            string year = time.Year.ToString();
            string month = time.Month.ToString();
            string day = time.Day.ToString();
            string hour = time.Hour.ToString();
            string min = time.Minute.ToString();
            string second = time.Second.ToString();
            byte[] arr = new byte[6];
            arr[0] = Convert.ToByte(year.Substring(2, 2), 16);
            //arr[] = Convert.ToByte(year.Substring(0, 2), 16);
            arr[1] = Convert.ToByte(month, 16);
            arr[2] = Convert.ToByte(day, 16);
            arr[3] = Convert.ToByte(hour, 16);
            arr[4] = Convert.ToByte(min, 16);
            arr[5] = Convert.ToByte(second, 16);
            return arr;   
        }
        #endregion

        #region  判断是否int或是decimal返回 byte[] IsIntOrDecimalToByteArray(string str)
        public static byte[] IsIntOrDecimalToByteArray(string str)
        {
            string[] ss = null;
            string num_int = null, num_dec = null;
            byte[] data_int = null, data_dec = null,data =new byte[6];
            if (str.Contains("."))
            {
                ss = str.Split('.');
                num_int = ss[0].PadLeft(8, '0');//整数部分
                num_dec = ss[1].PadRight(4, '0');//小数部分
            }
            else
            {
                num_int = str.PadLeft(8, '0');//整数部分
                num_dec = "0000";//小数部分
            }

            data_int = HexToByteByLow(num_int);
            data_dec = HexToByteByLow(num_dec);

            
            // MessageBox.Show(num_int+"#####"+data_int.Length.ToString() + "#############"+ num_dec + "#####" + data_dec.Length.ToString());
            Array.Copy(data_dec, 0, data, 0, data_dec.Length);
            Array.Copy(data_int, 0, data, data_dec.Length, data_int.Length);

            return data;
        }
        #endregion 

        #endregion

        #endregion

        #region 压包返回16进制字符串
        /// <summary>
        /// 根据指令类型返回 命令字符串
        /// </summary>
        /// <param name="cmdType">命令类型</param>
        /// <param name="mAddr">水表表地址</param>
        /// <param name="arr">要传进的参数 参数的顺序按照 文档的字段 顺序(从14字节开始)</param>
        /// <returns></returns>
        public static string PackToStr(CmdType cmdType, string mAddr,params object[] arr)
        {
            #region//定义变量
            string cmdStr = null;
            ClientInfo info = new ClientInfo();
            //info.BSendArr = "";
            info.Address = mAddr;
            info.CmdType = cmdType;
            byte[] data = null,tempArr = null,timeArr = null;
            string newAddress = null;
            // 下载程序 
            int totalLen = 0, totalNum = 0, numLen = 0, passwd = 0;//总长度 
            #endregion

            try
            {
                switch (cmdType)
                {
                    case CmdType.ReadVer:
                        break;
                    case CmdType.ReadTime:
                        break;
                    case CmdType.ReadReportParam:
                        break;
                    case CmdType.ReadMeterAddr:
                        break;
                    case CmdType.ReadMeterParam:
                        break;
                    case CmdType.ReadNetParam: // 获取 设置NB连接参数的16进制码
                        
                        break;
                    case CmdType.ReadMeterInterval:
                        break;
                    case CmdType.ReadMeterInterval_down:
                        break;
                    case CmdType.ReadReportInfo:
                        break;
                    case CmdType.ReadFreq:
                        break;
                    case CmdType.ReadReportInterval:
                        break;
                    case CmdType.ReadSysInterval:
                        break;
                    case CmdType.ReadSIM:
                        break;
                    case CmdType.ReadFlowAlarm:
                        break;
                    case CmdType.ReadPressuceParam:
                        break;
                    case CmdType.ReadHistory:
                        break;
                    case CmdType.WriteTime:
                        break;
                    case CmdType.WriteReportParam: // 获取 设置上报间隔的16进制码
                        if (arr.Length == 2)
                        {
                            timeArr = TimeToByteArray(Convert.ToDateTime(arr[0]));  // 上报的时间
                            tempArr = HexToByteByLow(Convert.ToString(Convert.ToInt16(arr[1]), 16).PadLeft(4, '0'));// 间隔数
                            info.BSendArr = new byte[8];
                            Array.Copy(timeArr, 0, info.BSendArr, 0, timeArr.Length);
                            Array.Copy(tempArr, tempArr.Length, info.BSendArr, timeArr.Length, tempArr.Length);
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteReportParam_down:// 获取 设置采集器上报间隔的16进制码
                        if (arr.Length == 2)
                        {
                            timeArr = TimeToByteArray(Convert.ToDateTime(arr[0])); // 上报的时间
                            tempArr = HexToByteByLow(Convert.ToString(Convert.ToInt16(arr[1]), 16).PadLeft(4,'0'));// 间隔数
                            info.BSendArr = new byte[8];
                            Array.Copy(timeArr,0,info.BSendArr,0,timeArr.Length);
                            Array.Copy(tempArr,tempArr.Length,info.BSendArr,timeArr.Length,tempArr.Length);
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteMeterAddr:// 设置表地址
                        if (arr.Length == 1)
                        {
                            newAddress = arr[0].ToString();// 水表地址
                            newAddress = newAddress.PadLeft(14, '0'); // 格式话水表地址长度
                            info.BSendArr = GetAddrFromStr(newAddress); 
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteMeterParam: // 获取 设置表底数的16进制码
                        if (arr.Length == 2)
                        {
                            info.BSendArr = SetMeterParams(arr[0].ToString(), arr[1].ToString()); 
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteNetParam:
                        if (arr.Length == 3)
                        {
                            string apn = arr[0].ToString(); // 接入点
                            string ip = arr[1].ToString();  // ip地址
                            string port = arr[2].ToString(); // 端口号
                            int port_int = Convert.ToInt32(port);
                            string[] ipArr = null;
                            ipArr = ip.Split('.');
                            if (ipArr.Length != 4)// 判断ip拆分后的长度
                            {
                                break;
                            }
                            apn = apn.PadRight(16, '\0');

                            info.BSendArr = new byte[23];
                            tempArr = Encoding.ASCII.GetBytes(apn);
                            Array.Copy(tempArr, 0, info.BSendArr, 0, tempArr.Length);
                            info.BSendArr[16] = 0x01;
                            info.BSendArr[17] = Convert.ToByte(ipArr[0]);
                            info.BSendArr[18] = Convert.ToByte(ipArr[1]);
                            info.BSendArr[19] = Convert.ToByte(ipArr[2]);
                            info.BSendArr[20] = Convert.ToByte(ipArr[3]);
                            info.BSendArr[21] = (byte)(port_int >> 8);
                            info.BSendArr[22] = (byte)(port_int & 0xff);

                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteAlarm:
                        break;
                    case CmdType.WriteSwitch:
                        break;
                    case CmdType.WriteReportInfo:
                        break;
                    case CmdType.WriteReportInterval:// 获取 设置重发次数的16进制码
                        if(arr.Length == 1)
                        {
                            info.BSendArr = IsIntOrDecimalToByteArray(arr[0].ToString());
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteAllParam:
                        break;
                    case CmdType.WriteFlowAlarm:// 获取 设置最大流量报警的16进制码
                        if (arr.Length == 1)
                        {
                            info.BSendArr = IsIntOrDecimalToByteArray(arr[0].ToString());
                            data = Pack(info);
                        }
                        break;
                    case CmdType.WriteSysInterval:
                        break;
                    case CmdType.WriteFreq:
                        break;
                    case CmdType.WritePressureParam:
                        break;
                    case CmdType.ClearHistory:
                        break;
                    case CmdType.Send_Update: // 启动下载程序功能
                        if (arr.Length == 4)
                        {
                            totalLen = Convert.ToInt32(arr[0]);
                            totalNum = Convert.ToInt32(arr[1]);
                            numLen = Convert.ToInt32(arr[2]);
                            passwd = Convert.ToInt32(arr[3]);
                            info.BSendArr = IsIntOrDecimalToByteArray(arr[0].ToString());
                            data = Pack(info);
                        }
                        break;
                    case CmdType.Send_Update_date:
                        break;
                    case CmdType.Send_Finish:
                        break;
                    case CmdType.WriteProgramParam:
                        break;
                    case CmdType.ReadProgramParam:
                        break;
                    case CmdType.ReadProgramAllParam:
                        break;
                    case CmdType.ReadHistoryOneNet:
                        break;
                    default:
                    case CmdType.NoCmd:
                        break;
                }

                if (data != null)
                {
                    cmdStr = ByteToHexStr(data);
                }
            }
            catch (Exception ex)
            {
                LogUtil.WriteLog("方法PackToStr() -->" + ex.Message);
            }
            return cmdStr;
        }

        #region 压包辅助方法

        #region  设置表底
        public static byte[] SetMeterParams(string totalUp,string totalDown)
        {
            byte[] dataTotal = null;
             
            byte[] dataUp= null, dataDown= null;

            if (totalUp.Length <= 13)
            {
                dataUp = IsIntOrDecimalToByteArray(totalUp);
                dataDown = IsIntOrDecimalToByteArray(totalDown);
                dataTotal = new byte[12];
                Array.Copy(dataUp, 0, dataTotal, 0, dataUp.Length);
                Array.Copy(dataDown, 0, dataTotal, dataUp.Length, dataDown.Length);
            }
            return dataTotal;
        }
        #endregion

        #endregion

        #endregion

    }
}
